package com.qmth.jkserver.model;

//import java.io.Serializable;
//import java.util.Date;
//
//import org.springframework.data.annotation.Id;
//import org.springframework.data.mongodb.core.index.CompoundIndex;
//import org.springframework.data.mongodb.core.index.CompoundIndexes;
//import org.springframework.data.mongodb.core.index.Indexed;
//import org.springframework.data.mongodb.core.mapping.Document;
//import org.springframework.data.mongodb.core.mapping.Field;
//
//import com.qmth.jkserver.enums.ProgressType;
//
///**
// * 统计当前考场内考生答案上传情形
// * 通用机考、优特机考，不支持视唱机考
// * @author tianjun
// *
// */
//@Document(collection = "jk_exam_kj_progress")
//@CompoundIndexes({
//	@CompoundIndex(name = "jk_exam_kj_progress_idx", def = "{'exam_code': 1, 'place_code': 1,'room_code':1}")
//})
//public class ExamKjProgress implements Serializable {
//
//	/**
//	 *
//	 */
//	private static final long serialVersionUID = -655536361256936227L;
//
//	@Id
//	private String id;
//
//	@Indexed
//	@Field("exam_code")
//	private String examCode;
//
//	@Field("place_code")
//	private String placeCode;
//
//	@Field("room_code")
//	private String roomCode;
//
//	@Field("type")
//	private ProgressType type;
//
//	//当前考场的最新答案数据包文件
//	@Field("attachment")
//    //TODO 需转换attachment_id
//	private Attachment attachment;
//
//	@Field("start_time")
//	private Date startTime;
//
//	/**
//	 * @return the type
//	 */
//	public ProgressType getType() {
//		return type;
//	}
//
//	/**
//	 * @param type the type to set
//	 */
//	public void setType(ProgressType type) {
//		this.type = type;
//	}
//
//	/**
//	 * @return the id
//	 */
//	public String getId() {
//		return id;
//	}
//
//	/**
//	 * @param id the id to set
//	 */
//	public void setId(String id) {
//		this.id = id;
//	}
//
//	/**
//	 * @return the examCode
//	 */
//	public String getExamCode() {
//		return examCode;
//	}
//
//	/**
//	 * @param examCode the examCode to set
//	 */
//	public void setExamCode(String examCode) {
//		this.examCode = examCode;
//	}
//
//	/**
//	 * @return the placeCode
//	 */
//	public String getPlaceCode() {
//		return placeCode;
//	}
//
//	/**
//	 * @param placeCode the placeCode to set
//	 */
//	public void setPlaceCode(String placeCode) {
//		this.placeCode = placeCode;
//	}
//
//	/**
//	 * @return the roomCode
//	 */
//	public String getRoomCode() {
//		return roomCode;
//	}
//
//	/**
//	 * @param roomCode the roomCode to set
//	 */
//	public void setRoomCode(String roomCode) {
//		this.roomCode = roomCode;
//	}
//
//	/**
//	 * @return the attachment
//	 */
//	public Attachment getAttachment() {
//		return attachment;
//	}
//
//	/**
//	 * @param attachment the attachment to set
//	 */
//	public void setAttachment(Attachment attachment) {
//		this.attachment = attachment;
//	}
//
//	/**
//	 * @return the startTime
//	 */
//	public Date getStartTime() {
//		return startTime;
//	}
//
//	/**
//	 * @param startTime the startTime to set
//	 */
//	public void setStartTime(Date startTime) {
//		this.startTime = startTime;
//	}
//}

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.jkserver.enums.ProgressType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * <p>
 * 统计当前考场内考生答案上传情形
 * </p>
 *
 * @author wangliang
 * @since 2023-03-01
 */
@ApiModel(value="JkExamKjProgress对象", description="统计当前考场内考生答案上传情形")
@TableName("jk_exam_kj_progress")
public class ExamKjProgress implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @ApiModelProperty(value = "考试编码")
    private String examCode;

    @ApiModelProperty(value = "地方编码")
    private String placeCode;

    @ApiModelProperty(value = "考场编码")
    private String roomCode;

    @ApiModelProperty(value = "类型，LOCAL：本地导入，REMOTE：监考端提交")
    private ProgressType type;

    @ApiModelProperty(value = "附件id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long attachmentId;

    @ApiModelProperty(value = "开始时间")
    private Long startTime;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getExamCode() {
        return examCode;
    }

    public void setExamCode(String examCode) {
        this.examCode = examCode;
    }

    public String getPlaceCode() {
        return placeCode;
    }

    public void setPlaceCode(String placeCode) {
        this.placeCode = placeCode;
    }

    public String getRoomCode() {
        return roomCode;
    }

    public void setRoomCode(String roomCode) {
        this.roomCode = roomCode;
    }

    public ProgressType getType() {
        return type;
    }

    public void setType(ProgressType type) {
        this.type = type;
    }

    public Long getAttachmentId() {
        return attachmentId;
    }

    public void setAttachmentId(Long attachmentId) {
        this.attachmentId = attachmentId;
    }

    public Long getStartTime() {
        return startTime;
    }

    public void setStartTime(Long startTime) {
        this.startTime = startTime;
    }
}
